#!/usr/local/bin/wish4.2 -f

# $Id: dlgfnew.tcl,v 1.1 1997/09/01 17:53:28 wtcorrea Exp $

set file_new_ret(ok) 0
set file_new_ret(width) -1
set file_new_ret(height) -1

proc file_new_dlg {} {
    global file_new_ret

    # pop up window
    toplevel .top 
    wm maxsize .top 290 150
    wm minsize .top 290 150
    wm title .top {New File}

    # message
    frame .top.frame1 -bd 2
    message .top.frame1.msg -text {Please enter picture dimensions.} \
        -aspect 1500
    
    # space
    frame .top.frame2 -bd 2
    frame .top.frame2.space -bd 2 -width 50

    # labels
    frame .top.frame2.labels -bd 2
    label .top.frame2.labels.width -text {Width:}
    label .top.frame2.labels.height -text {Height:}

    # entries
    frame .top.frame2.entries -bd 2
    entry .top.frame2.entries.width -relief sunken -width 4
    entry .top.frame2.entries.height -relief sunken -width 4

    # buttons
    frame .top.frame3 -bd 10
    button .top.frame3.ok -text OK -width 7 -command {
        set file_new_ret(width) [.top.frame2.entries.width get]
        set file_new_ret(height) [.top.frame2.entries.height get]
        set file_new_ret(ok) 1
    }
    button .top.frame3.cancel -text Cancel -width 7 -command {
        set file_new_ret(width) -1
        set file_new_ret(height) -1
        set file_new_ret(ok) 0
    }

    # bindings
    bind .top <Return> {
        set file_new_ret(width) [.top.frame2.entries.width get]
        set file_new_ret(height) [.top.frame2.entries.height get]
        set file_new_ret(ok) 1
    }
    bind .top <Escape> {
        set file_new_ret(width) -1
        set file_new_ret(height) -1
        set file_new_ret(ok) 0
    }

    # pack widgets
    pack .top.frame1 .top.frame2 .top.frame3 -side top -fill x
    pack .top.frame1.msg -side top -anchor w
    pack .top.frame2.space -side left -fill y
    pack .top.frame2.labels -side left -fill both
    pack .top.frame2.entries -side left -fill both
    pack .top.frame2.labels.width -side top -anchor w
    pack .top.frame2.labels.height -side top -anchor w
    pack .top.frame2.entries.width -side top -anchor w
    pack .top.frame2.entries.height -side top -anchor w
    pack .top.frame3.ok -side left -expand yes
    pack .top.frame3.cancel -side left -expand yes

    # default values
    .top.frame2.entries.width insert end 640
    .top.frame2.entries.height insert end 480

    # wait for user input
    grab .top
    focus .top.frame2.entries.width
    tkwait variable file_new_ret(ok)
    grab release .top
    destroy .top
}
