# $Id: drawarea.tcl,v 1.9 1997/09/15 09:02:02 wtcorrea Exp $

scrollbar .hscroll -orient horizontal -command {.canvas xview}
scrollbar .vscroll -orient vertical -command {.canvas yview}
pack .hscroll -side bottom -fill x
pack .vscroll -side right -fill y

canvas .canvas \
    -width $width -height $height \
    -scrollregion "0 0 [expr $width - 1] [expr $height - 1]" \
    -xscrollincrement 1 -yscrollincrement 1 \
    -xscrollcommand {.hscroll set} \
    -yscrollcommand {.vscroll set}
    
set appwin [GLxwin .canvas.appwin -width $width -height $height]
$appwin winset
.canvas create window 0 0 -anchor nw -window $appwin
pack .canvas -side left -anchor nw
    
bind $appwin <Configure> {
    app_redraw
    $appwin swapbuffers
}

bind $appwin <Expose> {
    app_redraw
    $appwin swapbuffers
}

bind $appwin <Button-1> {
    app_click1 %x %y %s
    if {$redraw} {
        app_redraw
        $appwin swapbuffers
    }
}

bind $appwin <Double-Button-1> {
    app_dclick1 %x %y %s
    if {$redraw} {
        app_redraw
        $appwin swapbuffers
    }
}

bind $appwin <ButtonRelease-1> {
    app_release1 %x %y
    if {$redraw} {
        app_redraw
        $appwin swapbuffers
    }
}

bind $appwin <Motion> {
    app_motion %x %y
    if {$redraw} {
        app_redraw
        $appwin swapbuffers
    }
}

bind $appwin <B1-Motion> {
    app_motion1 %x %y
    if {$redraw} {
        app_redraw
        $appwin swapbuffers
    }
}
