/* $Id: line.c,v 1.4 1997/09/15 14:41:33 wtcorrea Exp $ */

#include <assert.h>
#include <stdlib.h>
#include "graphics.h"
#include "device.h"
#include "my.h"
#include "macros.h"

extern int usedev;

line_t *line_new(int x1, int y1, int x2, int y2)
{
    line_t *l;

    l = malloc(sizeof(line_t));
    assert(l);
    l->v[0].x = x1, l->v[0].y = y1, l->v[1].x = x2, l->v[1].y = y2;
    return l;
}

void line_free(line_t *l)
{
    if (l != NULL) {
	free(l);
    }
}

void line_draw(const line_t *l, const attr_t *attr)
{
    assert(l);
    assert(attr);
    if (usedev) {
	dev_set_line_attr(attr);
	dev_draw_line(l->v[0].x, l->v[0].y, l->v[1].x, l->v[1].y);
    } else {
	my_set_line_attr(attr);
	my_draw_line(l->v[0].x, l->v[0].y, l->v[1].x, l->v[1].y);
    }
}

void line_draw_handles(const line_t *l)
{
    assert(l);
    gr_draw_handle(l->v[0].x, l->v[0].y);
    gr_draw_handle(l->v[1].x, l->v[1].y);
}

void line_move(line_t *l, int dx, int dy)
{
    assert(l);
    l->v[0].x += dx, l->v[0].y += dy;
    l->v[1].x += dx, l->v[1].y += dy;
}

void line_lastpt(line_t *l, int x, int y)
{
    assert(l);
    l->v[1].x = x, l->v[1].y = y;
}

int line_pick(const line_t *l, int x, int y)
{
    return gr_pt_on_line(l->v[0].x, l->v[0].y, l->v[1].x, l->v[1].y, x, y) == 2;
}
