# $Id: menu.tcl,v 1.7 1997/09/15 14:52:23 wtcorrea Exp wtcorrea $

source dlgfnew.tcl
set usedev 1

frame .menubar -relief raised -bd 2
menubutton .menubar.file -text File -underline 0 \
    -menu .menubar.file.menu
menubutton .menubar.edit -text Edit -underline 0 \
    -menu .menubar.edit.menu
menubutton .menubar.arrange -text Arrange -underline 0 \
    -menu .menubar.arrange.menu
menubutton .menubar.options -text Options -underline 0 \
    -menu .menubar.options.menu
menubutton .menubar.help -text Help -underline 0 \
    -menu .menubar.help.menu

menu .menubar.file.menu -tearoff 0
.menubar.file.menu add command -label New -underline 0 \
    -accelerator "\tCtrl+N" -command file_new
.menubar.file.menu add command -label Open... -underline 0 \
    -accelerator "\tCtrl+O" -command file_open -state disabled
.menubar.file.menu add command -label Save -underline 0 \
    -accelerator "\tCtrl+S" -command file_save -state disabled
.menubar.file.menu add command -label "Save As..." -underline 5 \
    -command file_save_as -state disabled
.menubar.file.menu add command -label "Print..." -underline 0 \
    -accelerator "\tCtrl+P" -command file_print
.menubar.file.menu add separator
.menubar.file.menu add command -label Quit -underline 0 \
    -accelerator "\tCtrl+Q" -command file_quit

menu .menubar.edit.menu -tearoff 0
.menubar.edit.menu add command -label "Undo" -underline 0 \
    -accelerator "\tCtrl+Z" -command edit_undo -state disabled
.menubar.edit.menu add command -label "Redo" -underline 0 \
    -accelerator "\tCtrl+Y" -command edit_redo -state disabled
.menubar.edit.menu add separator
.menubar.edit.menu add command -label "Cut" -underline 2 \
    -accelerator "\tCtrl+X" -command edit_cut -state disabled
.menubar.edit.menu add command -label "Copy" -underline 0 \
    -accelerator "\tCtrl+C" -command edit_copy -state disabled
.menubar.edit.menu add command -label "Paste" -underline 0 \
    -accelerator "\tCtrl+V" -command edit_paste -state disabled
.menubar.edit.menu add command -label "Delete" -underline 2 \
    -accelerator "\tDel" -command edit_delete
.menubar.edit.menu add separator
.menubar.edit.menu add command -label "Select All" -underline 7 \
    -accelerator "\tCtrl+A" -command edit_sel_all

menu .menubar.arrange.menu -tearoff 0
.menubar.arrange.menu add command -label "Back" -underline 0 \
    -accelerator "\tCtrl+B" -command arrange_back
.menubar.arrange.menu add command -label "Lower" -underline 0 \
    -accelerator "\tCtrl+L" -command arrange_lower
.menubar.arrange.menu add command -label "Raise" -underline 0 \
    -accelerator "\tCtrl+R" -command arrange_raise
.menubar.arrange.menu add command -label "Front" -underline 0 \
    -accelerator "\tCtrl+F" -command arrange_front
.menubar.arrange.menu add separator
.menubar.arrange.menu add command -label "Group" -underline 0 \
    -accelerator "\tCtrl+G" -command arrange_group -state disabled
.menubar.arrange.menu add command -label "Ungroup" -underline 0 \
    -accelerator "\tCtrl+U" -command arrange_ungroup -state disabled

menu .menubar.options.menu -tearoff 0
.menubar.options.menu add check -label "Open GL Mode" -underline 0 \
    -accelerator "\tCtrl+T" -variable usedev
.menubar.options.menu add separator
.menubar.options.menu add command -label "Line..." -underline 0 \
    -command options_line -state disabled
.menubar.options.menu add command -label "Fill..." -underline 0 \
    -command options_fill -state disabled
.menubar.options.menu add command -label "Curve..." -underline 0 \
    -command options_curve -state disabled
.menubar.options.menu add command -label "Text..." -underline 0 \
    -command options_text -state disabled

menu .menubar.help.menu -tearoff 0
.menubar.help.menu add command -label "About..." -underline 0 \
    -command help_about

bind . <Control-n> file_new
bind . <Control-N> file_new
#bind . <Control-o> file_open
#bind . <Control-O> file_open
#bind . <Control-s> file_save
#bind . <Control-S> file_save
bind . <Control-p> file_print
bind . <Control-P> file_print
bind . <Control-q> file_quit
bind . <Control-Q> file_quit

#bind . <Control-z> edit_undo
#bind . <Control-Z> edit_undo
#bind . <Control-y> edit_redo
#bind . <Control-Y> edit_redo
#bind . <Control-x> edit_cut
#bind . <Control-X> edit_cut
#bind . <Control-c> edit_copy
#bind . <Control-C> edit_copy
#bind . <Control-v> edit_paste
#bind . <Control-V> edit_paste
bind . <Delete> edit_delete
bind . <Control-a> edit_sel_all
bind . <Control-A> edit_sel_all

bind . <Control-r> arrange_raise
bind . <Control-R> arrange_raise
bind . <Control-f> arrange_front
bind . <Control-F> arrange_front
bind . <Control-l> arrange_lower
bind . <Control-L> arrange_lower
bind . <Control-b> arrange_back
bind . <Control-B> arrange_back
#bind . <Control-g> arrange_group
#bind . <Control-G> arrange_group
#bind . <Control-u> arrange_ungroup
#bind . <Control-U> arrange_ungroup

bind . <Control-t> options_gl_mode
bind . <Control-T> options_gl_mode

pack .menubar -side top -fill x
pack .menubar.file -side left
pack .menubar.edit -side left
pack .menubar.arrange -side left
pack .menubar.options -side left
pack .menubar.help -side left
tk_menuBar .menubar .menubar.file .menubar.help
focus .menubar

proc file_new {} {
    global file_new_ret appwin

    file_new_dlg
    if {$file_new_ret(ok)} {
        set width $file_new_ret(width)
        set height $file_new_ret(height)
        .canvas config -width $width -height $height \
            -scrollregion "0 0 [expr $width - 1] [expr $height - 1]"
        $appwin config -width $width -height $height
        app_new $width $height
        app_redraw
        $appwin swapbuffers
    }
}

proc file_open {} {
    puts "file_open"
}

proc file_save {} {
    puts "file_save"
}

proc file_save_as {} {
    puts "file_save_as"
}

proc file_print {} {
    app_print
}

proc file_quit {} {
    exit
}

proc edit_undo {} {
    puts "edit_undo"
}

proc edit_redo {} {
    puts "edit_redo"
}

proc edit_cut {} {
    puts "edit_cut"
}

proc edit_copy {} {
    puts "edit_copy"
}

proc edit_paste {} {
    puts "edit_paste"
}

proc edit_delete {} {
    global appwin

    app_delete
    app_redraw
    $appwin swapbuffers
}

proc edit_sel_all {} {
    global appwin
    
    app_selall
    app_redraw
    $appwin swapbuffers
}

proc arrange_back {} {
    app_back
}

proc arrange_lower {} {
    app_lower
}

proc arrange_raise {} {
    app_raise
}

proc arrange_front {} {
    app_front
}

proc arrange_group {} {
    puts "arrange_group"
}

proc arrange_ungroup {} {
    puts "arrange_ungroup"
}

proc options_line {} {
    puts "options_line"
}

proc options_fill {} {
    puts "options_fill"
}

proc options_curve {} {
    puts "options_curve"
}

proc options_text {} {
    puts "options_text"
}

proc help_about {} {
    set about_text [join [list \
        "Project 1" \
        "COS 426" \
        "CS Department" \
        "Princeton Univerisity"] \n]
    tk_dialog .about "Draw" $about_text {} {} OK
}
